Program Lab5_6;
Uses {SysUtils,}Windows,Messages;
const
 ClsName='cls1';
var
 wndClass  : TWndClassEx;
 msg       : TMsg;
 W1        : HWND;
 Pressed   : boolean;
 OldPos    : integer;
 TempPos   : integer;
 TempPos2  : integer;


Function WinProc(hWnd: HWND; Msg: integer;
        wParam: longint; lParam: longint): longint; stdcall;
var
  hdc       :  THandle;
  ps        :  TPaintStruct;
  i,j       :  integer;
  Pen1      :  THandle;
  Pen0      :  THandle;
  Rect      :  TRect;
  x,y       :  integer;
  Button    :  integer;
  Point     :  TPoint;
  Brush1    :  THandle;
  Brush0    :  THandle;
Begin
  Result:=0;
  case Msg of
WM_DESTROY: PostQuitMessage(0);
WM_PAINT: begin
   if (Pressed) then begin //   ,   
    hdc:=BeginPaint(hwnd,ps); // 
    Pen1:=CreatePen(PS_SOLID,1,RGB(0,0,0));
    Pen0:=SelectObject(hdc,Pen1); //   ,    ,  Pen0  
    GetClientRect(hwnd,Rect); //   
    Brush1:=CreateSolidBrush(RGB(255,255,255));
    Brush0:=SelectObject(hdc,Brush1); //       
    Rectangle(hdc,SmallInt(loword(TempPos)),SmallInt(hiword(TempPos)),
      SmallInt(loword(TempPos))+Rect.right-
      Rect.left,SmallInt(hiword(TempPos))+Rect.bottom-Rect.top); // 
// TempPos            
    SelectObject(hdc,Pen0);
    SelectObject(hdc,Brush0);
    DeleteObject(Pen1);
    DeleteObject(Brush1);
    EndPaint(hwnd,ps);
   end else DefWindowProc(hwnd,msg,wparam,lparam);
 end;
WM_LBUTTONDOWN: begin //    ,    
    Pressed:=true; // Pressed=true,     
    SetCapture(hwnd); //  
   end;
WM_MOUSEMOVE: begin // ,    
    if (Pressed) then begin
     TempPos:=lParam; //   
     GetClientRect(hwnd,Rect);
     InvalidateRect(hwnd,@Rect,true);
     PostMessage(hwnd,WM_PAINT,0,0); // 
    end;
end;
WM_LBUTTONUP: begin // ,    
    Pressed:=false;
    GetClientRect(hwnd,Rect);
    Point.x:=SmallInt(loword(lParam));
    Point.y:=SmallInt(hiword(lParam));
    ClientToScreen(hwnd,Point); //    
    InvalidateRect(hwnd,@Rect,true);    
    MoveWindow(hwnd,Point.X,Point.Y,Rect.right-Rect.left,Rect.bottom-Rect.top,true); // 
   end;
WM_KEYUP: begin // 
   if (wParam=VK_ESCAPE) then begin //   ESC
     PostMessage(hwnd,WM_QUIT,0,0); //    
   end;
  end;
 else
    result:=DefWindowProc(hwnd,msg,wparam,lparam);
 end;
End;

BEGIN
  Pressed:=false;
  wndClass.cbSize:=sizeof(wndClass);
  wndClass.style:=cs_hredraw or cs_vredraw;
  wndClass.lpfnWndProc:=@WinProc;
  wndClass.cbClsExtra:=0;
  wndClass.cbWndExtra:=0;
  wndClass.hInstance:=hInstance;
  wndClass.hIcon:=loadIcon(0, idi_Application);
  wndClass.hCursor:=loadCursor(0, idc_Arrow);
  wndClass.hbrBackground:=GetStockObject(white_Brush);
  wndClass.lpszMenuName:=nil;
  wndClass.lpszClassName:=ClsName;
  wndClass.hIconSm:=loadIcon(0, idi_Application);
  RegisterClassEx(wndClass);
  W1:=CreateWindow(ClsName,'  1',WS_BORDER or WS_POPUP, //WS_POPUP -   
      CW_USEDEFAULT,CW_USEDEFAULT,400,350,0,0,hInstance,nil);
  ShowWindow(W1,SW_SHOW);
  while GetMessage(msg,0,0,0) do begin
   TranslateMessage(msg);
   DispatchMessage(msg);
  end;
END.
