Program Lab6_v7;
{$H+}
Uses Windows,Messages;
const
 ClsName='cls1';
 EditRus=1;
 EditTrans=2;
 Button=3;
var
 wndClass    : TWndClassEx;
 OldEditProc : pointer;
 msg         : TMsg;
 W1          : HWND;
 hEditRus    : HWND;
 hEditTrans  : HWND;
 hButton     : HWND;
 Translate   : array[''..''] of string[3] =
('A','B','V','G','D','E','ZH','Z','I','Y','K','L','M','N',
'O','P','R','S','T','U','F','H','C','CH','SH','SCH','''',
'Y','''','E','YU','YA',
'a','b','v','g','d','e','zh','z','i','y','k','l','m','n',
'o','p','r','s','t','u','f','h','c','ch','sh','sch','''',
'y','''','e','yu','ya');

Function IntToStr(Value:integer):string;
var
  Str : string;
Begin
 Str:='';
 repeat
  Insert(char((Value mod 10)+byte('0')),Str,1);
  Value:=Value div 10;
 until Value=0;
 IntToStr:=Str;
End;

Function StrToInt(Str:string):integer;
var
  Value : integer;
  i     : byte;
Begin
  Value:=0;
  for i:=1 to length(Str) do begin
   Value:=Value*10;
   Value:=Value+byte(Str[i])-byte('0');
  end;
  StrToInt:=Value;
End;

Function WinProc(hWnd: HWND; Msg: integer;
        wParam: longint; lParam: longint): longint; stdcall;
var
  Rect      :  TRect;
  BufStr1   :  AnsiString;
  BufStr2   :  AnsiString;
  i,j       :  word;
  Len       :  integer;
Begin
  Result:=0;
  case Msg of
WM_CREATE: begin
   GetClientRect(hwnd,Rect);
   with Rect do begin
    hEditRus:=CreateWindow('edit',nil,WS_VISIBLE or WS_THICKFRAME
     or WS_CHILD or WS_TABSTOP or ES_MULTILINE or ES_WANTRETURN or
     ES_AUTOVSCROLL,Left+10,Top+10,Right-20,(Bottom div 2)-18,hwnd,EditRus,
     hInstance,nil);
    hEditTrans:=CreateWindow('edit',nil,WS_VISIBLE or WS_THICKFRAME
     or WS_CHILD or ES_MULTILINE or ES_WANTRETURN
     or ES_AUTOVSCROLL,Left+10,(Bottom div 2)+16,
     Right-20,(Bottom div 2) - 10,hwnd,EditTrans,hInstance,nil);
    hButton:=CreateWindow('button','Transliterate',BS_DEFPUSHBUTTON or WS_CHILD
    or WS_TABSTOP,10,(Bottom div 2)-6,Right-20,21,hwnd,Button,hInstance,nil);
   end;
   ShowWindow(hButton,SW_SHOW);
   ShowWindow(hEditRus,SW_SHOW);
   SendMessage(hEditRus,EM_SETLIMITTEXT,2048,0);
   ShowWindow(hEditTrans,SW_SHOW);
   SetFocus(hEditRus);
  end;
WM_COMMAND: begin
   if ((loword(wParam)=Button) and
    (hiword(wParam)=BN_CLICKED)) then begin
    BufStr1:=' ';
    BufStr2:='';
    Len:=SendDlgItemMessage(hwnd,EditRus,WM_GETTEXT,2049,integer(@BufStr1[1]));
    SetLength(BufStr1,Len);
    for j:=1 to Length(BufStr1) do begin
     if (BufStr1[j]<'') then
      BufStr2:=BufStr2+BufStr1[j]
     else
      BufStr2:=BufStr2+Translate[BufStr1[j]];
    end;
    SendDlgItemMessage(hwnd,EditTrans,WM_SETTEXT,0,integer(@BufStr2[1]));
   end;
  end;
WM_DESTROY: PostQuitMessage(0);
 else
    result:=DefWindowProc(hwnd,msg,wparam,lparam);
 end;
End;

BEGIN
  wndClass.cbSize:=sizeof(wndClass);
  wndClass.style:=cs_hredraw or cs_vredraw;
  wndClass.lpfnWndProc:=@WinProc;
  wndClass.cbClsExtra:=0;
  wndClass.cbWndExtra:=0;
  wndClass.hInstance:=hInstance;
  wndClass.hIcon:=loadIcon(0, idi_Application);
  wndClass.hCursor:=loadCursor(0, idc_Arrow);
  wndClass.hbrBackground:=GetStockObject(LTGRAY_BRUSH);
  wndClass.lpszMenuName:=nil;
  wndClass.lpszClassName:=ClsName;
  wndClass.hIconSm:=loadIcon(0, idi_Application);
  RegisterClassEx(wndClass);
  W1:=CreateWindow(ClsName,'    1',WS_BORDER or WS_SYSMENU or WS_SIZEBOX,
      CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,0,0,hInstance,nil);
  ShowWindow(W1,SW_SHOW);
  while GetMessage(msg,0,0,0) do begin
    if not IsDialogMessage(W1,msg) then begin
      TranslateMessage(msg);
      DispatchMessage(msg);
    end;
  end;
END.
