Program Lab8_6;
Uses Windows,Messages;
const
 ClsName='cls1';
 TimerNumber=1; 
var
 wndClass : TWndClassEx;
 msg      : TMsg;
 W1       : HWND;
 HB,HC,HD : THandle;
 ThB,ThC  : integer;
 ThD      : integer;
 HEvent   : THandle;
 Strs     : array[1..10] of string[21] =
('AAAAAAAAAAAAAAAAAAAA'#0,'BBBBBBBBBBBBBBBBBBBB'#0,
 'CCCCCCCCCCCCCCCCCCCC'#0,'DDDDDDDDDDDDDDDDDDDD'#0,
 'EEEEEEEEEEEEEEEEEEEE'#0,'FFFFFFFFFFFFFFFFFFFF'#0,
 'GGGGGGGGGGGGGGGGGGGG'#0,'HHHHHHHHHHHHHHHHHHHH'#0,
 'IIIIIIIIIIIIIIIIIIII'#0,'JJJJJJJJJJJJJJJJJJJJ'#0);

{ B -     } 
Function ThreadB(data:pointer):dword; stdcall;
var
 Buffer : string[20];
 i      : byte;
Begin
 while (true) do begin
  WaitForSingleObject(HEvent,INFINITE); {,    ,
   ..     ,   
   }
  Buffer:=Strs[1];
  for i:=2 to 10 do begin
   Strs[i-1]:=Strs[i];
  end;
  Strs[10]:=Buffer;
  SetEvent(HEvent); {  -   }
 end;
End;

{ C -     ,   -   }
Function ThreadC(data:pointer):dword; stdcall;
var
 Buffer : string[20];
 K1,K2  : byte;
Begin
 while (true) do begin
  WaitForSingleObject(HEvent,INFINITE);
  K1:=random(10)+1;
  repeat
   K2:=random(10)+1;
  until K1<>K2;
  Buffer:=Strs[K1];
  Strs[K1]:=Strs[K2];
  Strs[K2]:=Buffer;
  SetEvent(HEvent);
 end;
End;

{  -     A}
Function WinProc(hWnd: HWND; Msg: integer;
        wParam: longint; lParam: longint): longint; stdcall;
var
  hdc       :  THandle;
  ps        :  TPaintStruct;
  i         :  byte;
  Rect      :  TRect;
Begin
  Result:=0;
  case Msg of
WM_CREATE: begin {     }
     HEvent:=CreateEvent(nil,false,true,'TestEvent'); { }
     HB:=CreateThread(nil,0,@ThreadB,nil,0,ThB); {    B  C}
     HC:=CreateThread(nil,0,@ThreadC,nil,0,ThC);
     SetTimer(hWnd,TimerNumber,1000,nil); {       }
    end;
WM_DESTROY: begin {   -  ,   : , , }
     TerminateThread(HB,0);
     TerminateThread(HC,0);
     CloseHandle(HEvent);
     KillTimer(hWnd,TimerNumber);
     PostQuitMessage(0);
   end;
WM_PAINT: begin {    }
   hdc:=BeginPaint(hwnd,ps);
   WaitForSingleObject(HEvent,INFINITE); {,    ,
   ..     ,   
   }
   for i:=1 to 10 do begin
    TextOut(hdc,7,7+20*i,@Strs[i][1],20);
   end;
   SetEvent(hEvent);
   EndPaint(hwnd,ps); {  -   }
 end;
WM_TIMER: begin {    1   }
  GetCLientRect(hWnd,Rect); {,     }
  InvalidateRect(hWnd,@Rect,true);
//  PostMessage(hWnd,WM_PAINT,0,0);
 end
 else
    result:=DefWindowProc(hwnd,msg,wparam,lparam);
 end;
End;

BEGIN
  wndClass.cbSize:=sizeof(wndClass);
  wndClass.style:=cs_hredraw or cs_vredraw;
  wndClass.lpfnWndProc:=@WinProc;
  wndClass.cbClsExtra:=0;
  wndClass.cbWndExtra:=0;
  wndClass.hInstance:=hInstance;
  wndClass.hIcon:=loadIcon(0, idi_Application);
  wndClass.hCursor:=loadCursor(0, idc_Arrow);
  wndClass.hbrBackground:=GetStockObject(white_Brush);
  wndClass.lpszMenuName:=nil;
  wndClass.lpszClassName:=ClsName;
  wndClass.hIconSm:=loadIcon(0, idi_Application);
  RegisterClassEx(wndClass);
  W1:=CreateWindow(ClsName,'  1',WS_BORDER or
      WS_MAXIMIZEBOX or WS_MINIMIZEBOX	or WS_SYSMENU or WS_SIZEBOX,
      CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,0,0,hInstance,nil);
  ShowWindow(W1,SW_SHOW);
  while GetMessage(msg,0,0,0) do begin
   TranslateMessage(msg);
   DispatchMessage(msg);
  end;
END.
